stages:
  - containerization
  - deployment

variables:
  APPLICATION_NAME: pantilt-controller
  DOCKER_IMAGE: ${DOCKER_HUB_USERNAME}/${APPLICATION_NAME}
  CERTIFICATE_DOMAIN: pantilt.iot.maximemoreillon.com

containerization:
  stage: containerization
  tags:
    - moreillon
  script:
    # Docker hub login
    - echo "${DOCKER_HUB_PASSWORD}" | docker login --username ${DOCKER_HUB_USERNAME} --password-stdin
    # Building the container image
    - docker build -t ${DOCKER_IMAGE} .
    # Pushing the image to the registry
    - docker push ${DOCKER_IMAGE}
    # Cleanup
    - docker image rm ${DOCKER_IMAGE}

deployment:
  stage: deployment
  tags:
    - moreillon
  script:
    - envsubst < kubernetes_manifest.yml | kubectl apply -f -
    - kubectl rollout restart deployment/${APPLICATION_NAME}
  environment:
    name: production
    kubernetes:
      namespace: ${KUBERNETES_NAMESPACE}
